// Original JavaScript by Z at "http://www.lysator.liu.se/~zap"
// More controls added by Twinpics
// ------------------------------------------------------------

var hexaDigit = "0123456789abcdef";

function checkDecimal(number)
{
var ch;

    if((number == null) || (number.length==0))
	{
        return false;
	}

    for(var i=0; i<number.length; i++) 
    {
		ch = number.substring(i, i+1);
        if((ch < "0" || ch > "9"))
		{
			return false;
		}
    }

    return true;
}

function checkHexa(number)
{
var ch;

    if((number == null) || (number.length==0))
	{
        return false;
	}

    for(var i=0; i<number.length; i++) 
    {
		ch = number.substring(i, i+1);
        if(hexaDigit.indexOf(ch.toLowerCase()) == -1)
		{
			return false;
		}
    }

    return true;
}

function hex(input, nb)
{
var output = "";

    while(input > 0)
    {
        output = hexaDigit.charAt(input & 0xf) + output
        input >>= 4;
    }

    while(output.length < nb)
    {
        output = "0" + output;
    }

    return output;
}

function error(arg1, arg2)
{
    arg1.value = "Err";
    arg2.value = "Err";

    arg1.focus();
    arg1.select();

    return "ERR"
}

function computeMac(hexa, pos)
{
var mac = hexa.form.mac;

    if(
		(hexa.value.length != 2)
	||
		!checkHexa(hexa.value)
	  )
    {
        return error(hexa, mac);
    }

    i = parseInt(hexa.value, 16);

    i <<= 8;
    if(i & 0x8000) i+= 0x20;
    if(i & 0x0800) i+= 0x10;
    i &= 0x7730;
    i += 0x1100 + pos;   

    mac.value = hex(i, 4);

    return "";
}


function computeHex(mac, pos)
{
var hexa = mac.form.hex;
var i;

    if(
		(mac.value.length != 4)
	||
		!checkDecimal(mac.value)
	  )
    {
        return error(mac, hexa);
    }

    i = parseInt(mac.value, 16);
    
    if(
	    ((i & 0xff00) == 0)
	||
	    ((i & 0xff00) > 0x8800)
	||
	    ((i & 0xf0) > 0x30)
	||
		((i & 0xf) != pos)
	  )
	{
		return error(mac, hexa);
	}
   
    i -= 0x1100;
    i |= ((i & 0x20) << 10);
    i |= ((i & 0x10) << 7);
    i >>= 8;

    hexa.value = hex(i, 2);

    return "";
}
